<?php
//******************************************************************************************************************************
// Major release - January 2019
// Modified version of original post to verify
// No longer uses the 'campaigns' parameter passed from web forms, it now uses campaign_id
// This version incorporates client response code
// Intended to eventually replace the original version
// 18Feb19 @CR - only call update tracking if tracking ID is not empty - ref: 18Feb19
// 19Feb19 @CR - commented out several fdebugs, was still calling verify camx php so changed it to verify php
// 4Apr19 @CR - disabled tracking here till further notice
//******************************************************************************************************************************
// 13May19 @CR - commented out debugs

require_once ("/home/verify/public_html/common/debug.php");
require_once ("/home/verify/public_html/opendatabase_verify.php");
require_once ("/home/verify/public_html/clean_query.php");
require_once("/home/verify/public_html/common/mailjet_api_add_to_list.php"); // added 14Dec16 @CR
require_once("/home/verify/public_html/common/write_domain_campaign_record.inc.php"); // added 20Sep18 @CR
//require_once("/home/verify/public_html/common/lead_tracking.inc.php"); // added 3Dec18 @CR - disabled till further notice - 4Apr19 @CR
require_once("/home/verify/public_html/common/check_allowable_domain_v2.php"); // required as this is called from other domains via ajax

//global $client_ref; // added 31Jan19 @CR - is it required?

//fdebug ("posttoverify.post.array=>" . print_r($_POST,true) . "<");
//fdebug ("posttoverify.server.array=>" . print_r($_SERVER,true) . "<");
//fdebug ("posttoverify.request.array=>" . print_r($_REQUEST,true) . "<");
//fdebug ("posttoverify.session.array=>" . print_r($_SESSION,true) . "<");

if (empty($_REQUEST)) {
    // nothing sent to this program - abort - intro 17Oct18 @CR
   fdebug ("no.data.sent.to.posttoverify");
   exit(0);
} //endif

opendatabase();

// AFFILIATE CODE
//fdebug ("posttoverify.request=>" . print_r($_REQUEST,true) . "<");
session_start();

foreach ($_REQUEST as $key => $value) {
    $skey = "'" . $key . "'";
    $_SESSION[$skey] = $value;
    //fdebug ("posttoverify.skey=>" . $skey . "< value=>" . $_SESSION[$skey] . "<");
} //endforeach
// to here - AFFILIATE CODE

$supplier_id = RTRIM($_REQUEST['supplier_id']);
$campaign_id = RTRIM($_REQUEST['campaign_id']); // introduced 27Nov18 @CR
$_SESSION['campaign_id'] = $campaign_id; // new 18Sep18 @CR
$_SESSION['supplier_id'] = $supplier_id; // reintroduced 15Aug17 @CR
//$campaigns = RTRIM($_REQUEST['campaigns']); // now redundant in web forms - 27Nov18 @CR

$password = cleanQuery(RTRIM($_REQUEST['m_password']));
$email = cleanQuery(RTRIM($_REQUEST['m_email']));
$nextpage = cleanQuery(RTRIM($_REQUEST['nextpage']));

// re POST variables (prefixes) from form that called this program ...
$standard_form_input = "m_"; // standard prefix for an input form variable
$checkbox_form_input = "c_"; // checkbox prefix for an input form variable

// First of all build up an array of all the MAIN fields.
// Loop round all POST fields.

while (list($key,$value) = each($_POST)) {

    if (substr($key,0,2) == $standard_form_input || substr($key,0,2) == $checkbox_form_input) {

        if (substr($key,0,2) == $checkbox_form_input && $value == "") {
            // checkbox POST variable was not ticked (checked) so give it a default value of "N" (ie false)
            $value = "N";
        } //endif

        $il = strlen($key) - 2;
        $core[] = array(substr($key,2),$value);

    } elseif (strtolower($key) == "addr1" || strtolower($key) == "addr2"
           || strtolower($key) == "addr3" || strtolower($key) == "town"
           || strtolower($key) == "county" || strtolower($key) == "business_name") {
        // added business_name in the or condition above - 9May16 @CR
        $core[] = array($key,$value);
    } //endif

} //endwhile

//***************************************************************************
// introduced 20Sep18 @CR
//
$http_referer = $_SERVER['HTTP_REFERER']; // eg. domain.co.uk/ppi/phpscript.php
$web_code = $_POST['web_code'];
$_SESSION['web_code'] = $web_code; // reintroduced 15Aug17 @CR
if (!empty($http_referer)) {
    writeDomainCampaignRecord($http_referer,$campaign_id,$web_code);
} //endif
//
// to here - introduced 20Sep18 @CR
//***************************************************************************


//***************************************************************************
// introduced 14Aug17 @CR
$web_reg_post_fields = array(
    'web_code',
    'supplier_id',
    'consumer_ip_address',
    'title',
    'firstname',
    'surname',
    'addr1',
    'addr2',
    'addr3',
    'town',
    'county',
    'postcode',
    'email',
    'phone',
    'dob');

// loop thru core key fields - those that form a part of the registration details should be captured
// in readiness for writing the registration record
for ($i=0; $i<count($core); $i++) {

    if (in_array($core[$i][0],$web_reg_post_fields)) {
        $core_key = $core[$i][0];
        $$core_key = $core[$i][1];
    } //endif

} //endfor

$registered_recently = 0;

// web registration record is written to here ...

// first check this record has not already been written to web registration table recently (ie within last 3 months)...

// added cleanQuery in next SQL - 2Aug19 @CR
$sql = "select count(*) as cnt from web_registration where (phone = '" . cleanQuery($phone) . "' or email = '" . cleanQuery($email) . "')";
$sql .= " and date_registered >= (now() - interval 3 month);";

$result = mysql_query($sql,$connection);

// rearranged following to only run if result successful - 2Aug19 @CR
if ($result) {

    if ($result_row = mysql_fetch_assoc($result)) {
        if (empty($result_row['cnt'])) {
            // new registration - ie not registered within past 3 months
            $registered_recently = 0;
        } else {
            // ie registered within past 3 months - dont proceed further
            $registered_recently = 1;
        } //endif
    } //endif

    if (empty($registered_recently)) {

        $web_code = $_POST['web_code'];
        $supplier_id = $_POST['supplier_id'];

        $sql = "insert into web_registration (";
        $sql .= "web_code,supplier_id,posting_ip_address,title,firstname,surname,addr1,addr2,addr3,";
        $sql .= "town,county,postcode,email,phone,dob) values";
        $sql .= "('" . cleanQuery($web_code) . "','" . cleanQuery($supplier_id) . "','" . cleanQuery($consumer_ip_address) . "'";
        $sql .= ",'" . cleanQuery($title) . "','" . cleanQuery($firstname) . "','" . cleanQuery($surname) . "'";
        $sql .= ",'" . cleanQuery($addr1) . "','" . cleanQuery($addr2) . "'";
        $sql .= ",'" . cleanQuery($addr3) . "','" . cleanQuery($town) . "','" . cleanQuery($county) . "'";
        $sql .= ",'" . cleanQuery($postcode) . "','" . cleanQuery($email) . "'";
        $sql .= ",'" . cleanQuery($phone) . "','" . cleanQuery($dob) . "');";

        $result = mysql_query($sql,$connection);

        if (!$result) {
            fdebug ("bad.sql=>" . $sql . "<");
        } //endif

        // successful write to web registration table
        // initialise these session vars for use in offerboard
        $_SESSION['web_reg_uid'] = mysql_insert_id($connection);

        // set up core variables as session variables ...
        for ($i=0; $i<count($core); $i++) {

            if (in_array($core[$i][0],$web_reg_post_fields)) {
                $core_key = $core[$i][0];
                $$core_key = $core[$i][1];
                $_SESSION[$core_key] = $$core_key;
            } //endif

        } //endfor

    } //endif
} else {
    // bad result in SQL ...
    fdebug ("bad.sql=>" . $sql . "<");
    $registered_recently = -1; // fault
} //endif
// to here - rearranged following to only run if result successful - 2Aug19 @CR

$sql = "select field_name from campaign_fields";
$sql .= " where campaign_id = " . $campaign_id;
$sql .= " and session_prepop_ptv_flg = 1";

$result = mysql_query($sql,$connection);

if (!$result) {
    fdebug ("bad.sql=>" . $sql . "<");
} else {
    while ($result_row = mysql_fetch_assoc($result)) {
        // eg this will create a session variable like:
        $field_name = $result_row['field_name'];
        $prepop_sess_var = 'c' . $campaign_id . '_prepop_' . $field_name;
        $post_var = 'm_' . $field_name;
        $_SESSION[$prepop_sess_var] = $_POST[$post_var];
    } //endif
} //endif

$web_reg_uid = $_SESSION['web_reg_uid']; // added 15Aug17 @CR

// Now we need to send all the campaigns to Verify
$now = date("d/m/Y H:m:s");
$nowt = date("Y-m-d H:m:s");

$url = 'https://verifyleads.co.uk/verify.php';

$fields = array(
    'supplier_id'=>urlencode($supplier_id),
    'campaign_id'=>urlencode($campaign_id)
);

for ($k=0; $k<count($core); $k++) {
    $fields[$core[$k][0]] = $core[$k][1];
} //endif

$result="not sent";

$fields["dob_text"] = $fields["dob_day"] . "/" . $fields["dob_month"] . "/" . $fields["dob_year"];

$fields_string = "";
//url-ify the data for the POST
foreach ($fields as $key => $value) {
    $fields_string .= $key . '=' . rawurlencode($value) . '&'; // added rawurlencode for each parameter value - 31Oct16 @CR
}

$fields_string = rtrim($fields_string,'&');

//open connection
$ch = curl_init();

//set the url, number of POST vars, POST data
curl_setopt($ch,CURLOPT_URL,$url);
curl_setopt($ch,CURLOPT_POST,true);
curl_setopt($ch,CURLOPT_POSTFIELDS,$fields_string);
curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);

//execute post
$result = curl_exec($ch);
$response = curl_getinfo( $ch );
//close connection
curl_close($ch);

// Something that was more of an issue with data coming from offerboard web pages, but should be applied to regular web form data too ...
// (back in Nov 2016) warnings in /var/spool/mail/verify eg. ...
// Warning: simplexml_load_string(): code>8</return_code><return_description>Invalid phone number: 0<202d><202d>07903836465
// changed it to utf8_encode it
// re: http://stackoverflow.com/questions/2507608/error-input-is-not-proper-utf-8-indicate-encoding-using-phps-simplexml-lo
// look for: 'i solved this using' on web page
$result_content = utf8_encode($result);
$xmlResponseFromVerify = json_decode(json_encode((array)simplexml_load_string($result_content)),1);

//fdebug ("xmlResponseFromVerify.array=>" . print_r($xmlResponseFromVerify,true) . "<");

$return_code = $xmlResponseFromVerify['return_code'];
$return_description = $xmlResponseFromVerify['return_description'];
$individual_id = $xmlResponseFromVerify['individual_id'];

if ($xmlResponseFromVerify['client_ref']) {
    //fdebug ("xml.client.ref.TRUE");
} else {
    //fdebug ("xml.client.ref.FALSE");
} //endif
//fdebug ("xml.client.ref=>" . $xmlResponseFromVerify['client_ref'] . "<");

//fdebug ("client_ref.1=>" . $client_ref . "<");
//if (empty($client_ref)) $client_ref = $xmlResponseFromVerify['client_ref'];
$client_ref = $xmlResponseFromVerify['client_ref'];
//fdebug ("client_ref.2=>" . $client_ref . "<");

$_SESSION['verify_return_code'] = $return_code;
$_SESSION['verify_return_description'] = $return_description;
$_SESSION['verify_individual_id'] = $individual_id;
$_SESSION['client_ref'] = $client_ref;

// introduced 21Jan19 @CR
// echo the data returned by Verify, which may include client post responses
// so that they are available for use in websites calling this program

echo '<input type="hidden" id="return_code" name="return_code" value="' . $return_code . '">';
echo '<input type="hidden" id="return_description" name="return_description" value="' . $return_description . '">';
echo '<input type="hidden" id="individual_id" name="individual_id" value="' . $individual_id . '">';
echo '<input type="hidden" id="m_client_ref" name="m_client_ref" value="' . $client_ref . '">'; // NB: m_client_ref (so processed as campaign field)

// mailjet info added to Verify DB ...
$mailjet_id = $_SESSION['m_mailjet_id'];
$email = $_SESSION['m_email'];
$firstname = $_SESSION['m_firstname'];
$lastname = $_SESSION['m_surname'];

if ($return_code == 0 && $return_description == 'Success' && !empty($mailjet_id)) {
    // a successful lead was added in Verify, but only add to our mailjet lead DB if a mailjet ID is present (ie has a value from the web form)
    addMailjetLead($individual_id,$mailjet_id,$email,$firstname,$lastname);
} //endif
// to here - mailjet info added to Verify DB ...


/********************************************************* disabled until further notice - 4Apr19 @CR
// introduced 3Dec18 @CR - TRACKING
if ($_SESSION['verify_return_code'] == 0) {
    // Verify lead is Accepted
    $mode = 'a';
} else {
    // Verify lead must be rejected
    $mode = 'r';
} //endif

$tracking_id = $_POST['verify_tracking_id'];

if (!empty($tracking_id)) {
    // only call update tracking if tracking ID is not empty - added condition 18Feb19 @CR
    updateTracking($mode,$campaign_id,$supplier_id,$publisher_id,$tracking_id,$individual_id);
} //endif
// to here - introduced 3Dec18 @CR - TRACKING
********************************************************* to here - disabled until further notice - 4Apr19 @CR */



// next page handled differently now - 2Feb19 @CR
//header("Location: " . $nextpage); // orig***
//exit(0);                          // orig***
if (!empty($nextpage)) {
    // next page has been specified from the original calling form
    // therefore it is assumed that the normal form action is being executed
    // whereas if called via ajax from web form next page SHOULD BE blank as
    // the redirection of page should be handled by ajax/js-function within form
    // and NOT by this program
    // By doing the original header redirection regardless (ref:orig*** above) ..., when posttoverify called from ajax, it was
    // messing up the ajax call and executing error response function in the ajax, and hence ajax failing!!!!!
    header("Location: " . $nextpage);
    exit(0);
} //endif

?>
