<?php

//**********************************************************************************
// Written 22Nov16 @CR
// Called from the UK Loan Centre form when submitted
// and this code intervenes just prior to presenting the
// thank you page.
// The form passes the original transaction ID (only applicable if original lead was
// sourced from an affiliate), and loan_amount value via post var
// and dependent on value this program will do 2 things:
// a) perform a postback to affiliates
// b) redirect to the relevant thank you page
// Reason for this 'intermediary' program is because we
// dont want to pass the loan amount value from the form to the actual thankyou page
// as it would then appear in the URL of thank you page.
//**********************************************************************************

require_once ("/home/verify/public_html/common/debug.php");

session_start(); // AFFILIATE CODE - MUST BE declared!!!

// these variables taking on their session equivalents (which are set in posttoverify)
$phone1 = $_SESSION['m_phone'];
$phone2 = $_SESSION['m_alt_phone'];

$affiliate_transaction_id = $_SESSION['affiliate_transaction_id'];

fdebug ("testform.prethankyou.postback#=>" . $postback . "< affiltid=>" . $affiliate_transaction_id . "<");

fdebug ("session.data=>" . print_r($_SESSION,true) . "<request.data=>" . print_r($_REQUEST,true) . "<");

// just as a way of using different postback URLs for testing:
// - use postback URL 1 if only 1 phone number provided
// - use postback URL 2 if only 2 phone numbers provided

$postback = 1;
if (!empty($phone1) && !empty($phone2)) {
    fdebug ("2 numbers provided");
    $postback = 2;
}

$goal_id = null;
$offer_id = 122;

switch ($postback) {
    case 1:
        $goal_id = 13;
        break;
    case 2:
        $goal_id = 15;
        break;
} //end switch

completeAffiliatePostback($offer_id,$goal_id,$affiliate_transaction_id);


function completeAffiliatePostback($offer_id,$goal_id,$affiliate_transaction_id) {

    if (empty($affiliate_transaction_id)) { return false; }

    $url = "http://www.rndtrk.com/aff_goal?a=lsr&goal_id=" . $goal_id . "&transaction_id=" . $affiliate_transaction_id;
    fdebug ("pre.thankyou.postback.url=>" . $url . "<");

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);

    $headers = array();
    $headers[] = "Content-Type: application/json";
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    $result = curl_exec($ch);
    $response = curl_getinfo($ch); // added myself 14Sep16 @CR
    $response_code = curl_getinfo($ch,CURLINFO_HTTP_CODE); // added myself 14Sep16 @CR

    if (curl_errno($ch)) {
        // return curl error as contact_id
        fdebug ("postback.false");
        return false;
    }
    curl_close ($ch);

    // this string is returned in $result if the postback itself was successful
    $success_string = "success=true;";
    // if this string is found in the $result and the http response code = 200 - the success is 100%

    if (strpos($result, $success_string) !== false && $response_code == 200) {
        fdebug ("postback.true");
        return true;
    }

} //end function

?>
